<?php

namespace Drupal\decoupled\Plugin\Field\FieldFormatter;

use Drupal\Component\Serialization\Json;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\text\Plugin\Field\FieldFormatter\TextDefaultFormatter;

/**
 * Implementation of the 'json_editor' formatter.
 *
 * @FieldFormatter(
 *   id = "jsonapi_editor",
 *   label = @Translation("Json:API Editor"),
 *   field_types = {
 *     "text_long",
 *     "text_with_summary"
 *   }
 * )
 */
class JsonApiFormatter extends TextDefaultFormatter{

    /**
     * {@inheritdoc}
     */
    public function viewElements(FieldItemListInterface $items, $langcode){
        $elements = [];
        $items->setValue('{
  "name": "drupal/json_editor",
  "description": "Json Editor is text formatter for drupal.",
  "type": "drupal-module",
  "license": "GPL-2.0+",
  "homepage": "https://www.drupal.org/project/json_editor",
  "authors": [
    {
      "name": "Websolutions Agency",
      "homepage": "https://www.drupal.org/websolutions-agency",
      "role": "Maintainer"
    }
  ],
  "support": {
    "issues": "https://www.drupal.org/project/issues/json_editor",
    "source": "http://cgit.drupalcode.org/json_editor"
  },
  "require": {}
}
');

        foreach ($items as $delta => $item) {
          $elements[$delta] = [
            '#theme' => 'json_editor',
            '#attached' => [
              'library' => 'json_editor/json-editor',
              'drupalSettings' => [
                'json_editor' => [
                  Json::decode($item->value)
                ]
              ]
            ]
          ];
        }
        return $elements;
    }
}